<template>
  <div class="app-container">
    <el-card shadow="hover" class="mb-[10px]">
      <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px" size="default" class="ry_form">
        <el-form-item label="状态" prop="showStatus">
          <DictRadio
            v-model="queryParams.showStatus"
            @change="handleQuery"
            :radioList="normalStatusMap"
            radioData="sys_normal_disable"
            :showAll="'all'"
          />
        </el-form-item>
        <el-form-item label="名称" prop="name">
          <el-input v-model="queryParams.nameLike" placeholder="名称" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item class="flex_one tr">
          <el-button type="primary" icon="Search" @click="handleQuery" v-hasPermi="['pms:brand:query']">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
    </el-card>

    <el-card shadow="hover">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd"  v-hasPermi="['pms:brand:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>
      <el-table v-loading="loading" :data="pmsBrandList" @selection-change="handleSelectionChange" border>
        <el-table-column label="品牌logo" prop="logo" align="center">
          <template v-slot="{ row }">
            <el-image v-if="row.logo" :src="row.logo" fit="cover" :preview-teleported="true" :preview-src-list="[row.logo]" />
          </template>
        </el-table-column>
        <el-table-column label="名称" prop="name" align="center" />
        <el-table-column label="排序" prop="sort" align="center" />
        <el-table-column label="状态" prop="showStatus" align="center">
          <template v-slot="{ row }">
            <dict-tag :options="normalStatusMap" :value="row.showStatus" prop-name="sys_normal_disable" />
          </template>
        </el-table-column>
        <el-table-column label="操作" class-name="small-padding fixed-width">
          <template v-slot="scope">
            <el-button text type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['pms:brand:edit']">修改 </el-button>
            <el-button text type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['pms:brand:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改品牌管理对话框 -->
    <el-dialog :title="title" v-model="open" width="50%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="108px" inline class="dialog-form-one">
        <el-form-item label="状态">
          <DictRadio v-model="form.showStatus" :radioList="normalStatusMap" radioData="sys_normal_disable" />
        </el-form-item>
        <br />
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="名称" />
        </el-form-item>
        <br />
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
        <br />
        <el-form-item label="logo" prop="logo">
          <oss-image-upload v-model="form.logo" :limit="1" />
        </el-form-item>
      </el-form>
      <template v-slot:footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script>
import { addPmsBrand, delPmsBrand, exportPmsBrand, getPmsBrand, listPmsBrand, updatePmsBrand } from '@/api/pms/brand';

export default {
  name: 'PmsBrand',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 品牌管理表格数据
      pmsBrandList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        nameLike: null,
        sort: null,
        showStatus: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      normalStatusMap: []
    };
  },
  async created() {
    this.getList();
    const normalStatusMap = await this.getDictionaryByKey('sys_normal_disable');
    this.normalStatusMap = normalStatusMap;
  },
  methods: {
    /** 查询品牌管理列表 */
    getList() {
      this.loading = true;
      const { pageNum, pageSize } = this.queryParams;
      const query = { ...this.queryParams, pageNum: undefined, pageSize: undefined };
      const pageReq = { current: pageNum - 1, size: pageSize };
      listPmsBrand(query, pageReq).then((response) => {
        const { records, total } = response.data || {};
        this.pmsBrandList = records;
        this.total = total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        sort: null,
        showStatus: 0,
        logo: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm('form');
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = '添加品牌管理';
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getPmsBrand(id).then((response) => {
        const { data } = response || {};
        if (data.showStatus != null) {
          data.showStatus = data.showStatus.toString();
        }
        this.form = data || {};
        this.open = true;
        this.title = '修改品牌管理';
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updatePmsBrand(this.form).then((response) => {
              this.$modal.msgSuccess('修改成功');
              this.open = false;
              this.getList();
            });
          } else {
            addPmsBrand(this.form).then((response) => {
              this.$modal.msgSuccess('新增成功');
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除品牌管理编号为"' + ids + '"的数据项？')
        .then(function () {
          return delPmsBrand(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess('删除成功');
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal
        .confirm('是否确认导出所有品牌管理数据项？')
        .then(() => {
          this.exportLoading = true;
          return exportPmsBrand(queryParams);
        })
        .then((response) => {
          this.$download.download(response);
          this.exportLoading = false;
        })
        .catch(() => {});
    }
  }
};
</script>
